\chapter*{Greeting Example}

\section*{Basics of our Greeting}

So now that we‘ve run our first example, we can walk through just
what‘s happening. Even though it‘s a simple program, there are a lot
of foundational elements in it that will come in handy for
understanding how much of our other example programs are structured.

\section*{Module Header}

Every Haskell \gls{module} should generally start with a
\gls{modhead}. This is a special comment explaining what the module
does, where it‘s from, licensing and copyright information, and how to
get in touch with the maintainer. The module header for
\haskexampleref{\haskellinline|BFWP.Greeting|}{exa:greeting:modhead}
contains:

\haskexample[lastline=10]{FunctionalWebExamples/Source/BFWP/Greeting.hs}{\Gls{modhead}}{greeting:modhead}

Next up is the actual start of the module code. This always is a
\haskellinline|module| statement, followed by the full module
name. This is basically the directories from the source root down to
the module Haskell file. It‘s also the way other \glspl{module} will
\haskellinline|import| this \gls{module}:

\haskexample[firstline=12,lastline=14]{FunctionalWebExamples/Source/BFWP/Greeting.hs}{Haskell \textit{module declaration}}{greeting:moduledecl}

Now, this shows a couple of things. First is the \Gls{explist}. The
export list is everything between the parentheses, and can span
several lines. It essentially lists all the names of the values and
types that this module exposes to other modules.

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../FunctionalWeb"
%%% End:
